#include <stdio.h>
#include <stdlib.h>

void print(const char *string, size_t size) {
	printf("%-12s:%3zu\n", string, size);
}

int main(void) {

	print("char", sizeof(char));
	print("short", sizeof(short));
	print("int", sizeof(int));
	print("long", sizeof(long));
	print("long long", sizeof(long long));
	print("float", sizeof(float));
	print("double", sizeof(double));
	print("long double", sizeof(long double));
	printf("\n");

	int a = 5;
	print("int variable", sizeof(a));
	//	for historical reasons character constant is type int
	print("'a'", sizeof('a'));
	print("(char)'a'", sizeof((char)'a'));
	print("\"a\"", sizeof("a"));
	print("12", sizeof(12));
	print("12l", sizeof(12l));
	print("12ul", sizeof(12ul));
	print("12ll", sizeof(12ll));
	print("12ull", sizeof(12ull));
	print("12.f", sizeof(12.f));
	print("12.", sizeof(12.));
	print("12.l", sizeof(12.l));

	return EXIT_SUCCESS;
}

